package  
{
	import Box2D.Common.Math.b2Vec2;
	import Box2D.Dynamics.b2Body;
	import org.flixel.FlxSprite;
	
	/**
	 * ...
	 * @author Marek Kapolka
	 */
	public class FlxPhysBody extends FlxSprite 
	{
		public static var WORLD_SCALE : Number = 1;
		
		protected var _body : b2Body;
		
		public function FlxPhysBody(x : Number, y : Number, sprite : Class, b : b2Body) 
		{
			super(x, y, sprite);
			
			_body = b;
		}
		
		public function get body():b2Body
		{
			return _body;
		}
		
		public function set rotation(r : Number):void
		{
			angle = r * -180 / Math.PI;
			_body.SetAngle(r);
		}
		
		public function get rotation():Number
		{
			return _body.GetAngle();
		}
		
		public function setPositionPixels(nx : Number, ny : Number):void
		{
			x = nx;
			y = ny;
			_body.SetPosition(new b2Vec2(nx / WORLD_SCALE, ny / WORLD_SCALE * -1));
			
		}
		
		override public function update():void
		{
			super.update();
			x = _body.GetPosition().x * WORLD_SCALE;
			y = _body.GetPosition().y * -1 * WORLD_SCALE;
			
			angle = _body.GetAngle() * -180 / Math.PI;
		}
		
	}

}