package  
{
	import Box2D.Collision.Shapes.b2CircleShape;
	import Box2D.Collision.Shapes.b2Shape;
	import Box2D.Common.Math.b2Vec2;
	import Box2D.Dynamics.b2Body;
	import Box2D.Dynamics.b2BodyDef;
	import Box2D.Dynamics.b2World;
	import org.flixel.FlxSprite;
	import org.flixel.FlxG;
	
	/**
	 * ...
	 * @author maerk
	 */
	public class FlxPhysball extends FlxSprite
	{
		[Embed(source = "../res/ball.png")]
		public static var ball_png : Class;
		
		private var _body : b2Body;
		
		public function FlxPhysball(sx : Number, sy : Number, w : b2World) 
		{
			super(0, 0, ball_png);
			
			var bd : b2BodyDef = new b2BodyDef();
			bd.position.Set(sx, sy);
			bd.type = b2Body.b2_dynamicBody;
			_body = w.CreateBody(bd);
			
			var s : b2CircleShape = new b2CircleShape(width / 2);
			
			_body.CreateFixture2(s, 1);
			
			offset.x = width / 2;
			offset.y = height / 2;
		}
		
		override public function update():void
		{
			super.update();
			
			x = _body.GetPosition().x;
			y = _body.GetPosition().y * -1;
			angle = _body.GetAngle() * -180 / Math.PI;
			
			if (FlxG.mouse.justPressed())
			{
				_body.SetPosition(new b2Vec2(FlxG.mouse.x, FlxG.mouse.y * -1));
				_body.SetLinearVelocity(new b2Vec2());
			}
		}
		
	}

}