package  
{
	import org.flixel.FlxState;
	import org.flixel.FlxText;
	import org.flixel.FlxG;
	import org.flixel.FlxGame;
	
	/**
	 * ...
	 * @author Marek Kapolka
	 */
	public class TextState extends FlxState 
	{
		private var _strings : Vector.<String>;
		private var _texts : Vector.<FlxText> = new Vector.<FlxText>();
		private var _nextState : FlxState;
		
		private var _revealing : FlxText;
		private var _countdown : Number = 0;
		private var _nextReveal : uint = 0;
		
		public function TextState(strings : Vector.<String>, nextState : FlxState) 
		{
			super();
			
			_strings = strings;
			_nextState = nextState;
			
			initText();
		}
		
		private function initText():void
		{
			var max : int = _strings.length + 2;
			
			var i : int = 1;
			
			for each (var s : String in _strings)
			{
				var t : FlxText = new FlxText(0, 0, FlxG.width);
				t.text = s;
				t.color = 0xFFFFFFFF;
				t.alignment = "center";
				
				t.size = 20;
				t.alpha = 0;
				
				t.x = 0;
				t.y = (FlxG.height / max) * i;
				
				add(t);
				_texts.push(t);
				
				i++;
			}
			
			_revealing = _texts[0];
		}
		
		private function next():void
		{
			if (_revealing)
			{
				_revealing.alpha = 1;
			}
			
			_nextReveal += 1;
					
			if (_nextReveal < _texts.length)
			{
				_revealing = _texts[_nextReveal];
				_countdown = 1;
			}
		}
		
		private function finish():void
		{
			FlxG.state = _nextState;
		}
		
		override public function update():void
		{
			super.update();
			
			if (FlxG.mouse.justPressed())
			{
				next();
				
				if (_nextReveal > _texts.length)
				{
					FlxG.fade.start(0xFF000000, 1, finish);
				}
			}
			
			if (_countdown < 0)
			{
				_revealing.alpha += FlxG.elapsed;
				
				if (_revealing.alpha >= 1)
				{
					next();
				}
			} else {
				_countdown -= FlxG.elapsed;
			}
		}
		
	}

}