package scene_1 
{
	import org.flixel.FlxGroup;
	import org.flixel.FlxSprite;
	import org.flixel.FlxG;
	
	/**
	 * ...
	 * @author Marek Kapolka
	 */
	public class HandCursor extends FlxGroup
	{
		[Embed(source = "../../res/scene_1/hands.png")]
		public static var hands_png : Class;
		
		[Embed(source = "../../res/scene_1/cursor_dot.png")]
		public static var cursor_dot_png : Class;
		
		public static const SPRITE_WIDTH : uint = 75;
		public static const SPRITE_HEIGHT : uint = 75;
		public static const POINTER_OFFSET_X : uint = 11;
		public static const POINTER_OFFSET_Y : uint = 13;
		
		private var _lock : Boolean = false;
		
		private var _hand : FlxSprite;
		private var _cursor : FlxSprite;
		
		public function HandCursor() 
		{
			super();
			
			_hand = new FlxSprite();
			
			_hand.loadGraphic(hands_png, false, false, 75, 75, true);
			_hand.addAnimation("point", [0]);
			_hand.addAnimation("hand", [1]);
			_hand.addAnimation("grab", [2]);
			
			_hand.play("point");
			
			_hand.alpha = .5;
			
			_hand.offset.x = POINTER_OFFSET_X;
			_hand.offset.y = POINTER_OFFSET_Y;
			
			_cursor = new FlxSprite(0, 0, cursor_dot_png);
			_cursor.alpha = .5;
			
			add(_hand);
			add(_cursor);
			lock = false;
		}
		
		public function set lock(b : Boolean):void
		{
			_lock = b;
			
			_cursor.visible = b;
		}
		
		public function get lock():Boolean
		{
			return _lock;
		}
		
		public function get hand():FlxSprite
		{
			return _hand;
		}
		
		public function get cursor():FlxSprite
		{
			return _cursor;
		}
		
		public function play(s : String):void
		{
			_hand.play(s);
		}
		
		override public function update():void
		{
			if (!_lock)
			{
				var dx : Number = FlxG.mouse.x - _hand.x;
				var dy : Number = FlxG.mouse.y - _hand.y;
				
				//x = FlxG.mouse.x;
				//y = FlxG.mouse.y;
				
				_hand.x += dx * .8;
				_hand.y += dy * .8;
			} else {
				_cursor.x = FlxG.mouse.x;
				_cursor.y = FlxG.mouse.y;
			}
			
			super.update();
		}
		
	}

}