package scene_1 
{
	import org.flixel.FlxSprite;
	import org.flixel.FlxG;
	
	/**
	 * ...
	 * @author Marek Kapolka
	 */
	public class Heart extends FlxSprite 
	{
		[Embed(source = "../../res/scene_1/heart.png")]
		public static var heart_png : Class;
		
		public static const MIN_SCALE : Number = .5;
		public static const MAX_SCALE : Number = .7;
		
		private static const TARGET_V : Number = 10;
		
		private var _beat : Number = 0;
		private var _v : Number = 0;
		
		private var _started : Boolean = false;
		
		public function Heart(x : Number, y : Number) 
		{
			super(x, y, heart_png);
			
			offset.x = width / 2;
			offset.y = height / 2;
		}
		
		public function set beatVelocity(n : Number):void
		{
			if (!_started)
			{
				_v = n;
			}
		}
		
		public function get beatVelocity():Number
		{
			return _v;
		}
		
		public function set beatCounter(n : Number):void
		{
			var s : Number = Math.sin(n);
			
			s = Math.abs(s);
			s = s * s * s;
			
			var sc : Number = MIN_SCALE + (MAX_SCALE - MIN_SCALE) * s;
			
			scale.x = sc;
			scale.y = sc;
			
			_beat = n;
		}
		
		public function get beatCounter():Number
		{
			return _beat;
		}
		
		public function get started():Boolean
		{
			return _started;
		}
		
		override public function update():void
		{
			beatCounter += FlxG.elapsed * _v;
			
			if (!_started)
			{
				_v -= FlxG.elapsed * 3;
				if (_v > 10) _started = true;
			} else {
				var dv : Number = TARGET_V - _v;
				
				_v += dv * .8 * FlxG.elapsed;
			}
			
			if (_v < 0) _v = 0;
			
			super.update();
		}
		
	}

}