package scene_1 
{
	import org.flixel.FlxSprite;
	import org.flixel.FlxG;
	
	/**
	 * ...
	 * @author Marek Kapolka
	 */
	public class Lungs extends FlxSprite 
	{
		[Embed(source = "../../res/scene_1/lungs.png")]
		public static var lungs_png : Class;
		
		public static const MIN_SCALE : Number = .8;
		public static const MAX_SCALE : Number = 1;
		
		private var _pumped : Number = 0;
		private var _started : Boolean = false;
		private var _inhaling : Boolean = false;
		
		public function Lungs(x : Number, y : Number ) 
		{
			super(x, y, lungs_png);
			
			offset.x = width / 2;
			offset.y = height / 2;
			
			pumped = _pumped;
		}
		
		public function set pumped(v : Number):void
		{
			if (v < 0) v = 0;
			if (v > 1) v = 1;
			
			var s : Number = MIN_SCALE + (MAX_SCALE - MIN_SCALE) * v;
			scale.x = s;
			scale.y = s;
			
			if (!_started && v > .8)
			{
				_started = true;
			}
			
			_pumped = v;
		}
		
		public function get pumped():Number
		{
			return _pumped;
		}
		
		public function set started(b : Boolean):void
		{
			_started = b;
		}
		
		public function get started():Boolean
		{
			return _started;
		}
		
		override public function update():void
		{
			if (_started)
			{
				if (_inhaling)
				{
					pumped += FlxG.elapsed;
					
					if (pumped == 1)
					{
						_inhaling = false;
					}
				} else {
					pumped -= FlxG.elapsed;
					
					if (pumped == 0)
					{
						_inhaling = true;
					}
				}
			} else {
				pumped -= FlxG.elapsed / 2;
			}
			
			super.update();
		}
		
	}

}