package scene_1 
{
	import flash.geom.Rectangle;
	import scene_1.PlungerTexture;
	import org.flixel.FlxGroup;
	import org.flixel.FlxG;
	import org.flixel.FlxPoint;
	import org.flixel.FlxSprite;
	
	/**
	 * ...
	 * @author maerk
	 */
	public class Plunger extends FlxGroup implements Grabable
	{
		[Embed(source = "../../res/scene_1/plunger.png")]
		public static var plunger_png : Class;
		
		[Embed(source = "../../res/scene_1/plunger_handle.png")]
		public static var plunger_handle_png : Class;
		
		private var _plungerSprite : FlxSprite;
		private var _handleSprite : FlxSprite;
		private var _stomach : Stomach;
		
		private var _texture : PlungerTexture = new PlungerTexture();
		
		private var _p : FlxPoint = new FlxPoint();
		
		private var _held : Boolean = false;
		
		private var _sx : Number;
		private var _psx : Number;
		private var _ppp : Number;
		private var _px : Number = 0;
		
		private var _td : Number = 0;
		
		public function Plunger(s : Stomach) 
		{
			super();
			
			_stomach = s;
			
			_plungerSprite = new FlxSprite(0, 0, plunger_png);
			_handleSprite = new FlxSprite(0, 0, plunger_handle_png);
			
			_plungerSprite.offset.x = _plungerSprite.width / 2;
			_plungerSprite.offset.y = _plungerSprite.height / 2;
			
			_handleSprite.offset.x = _handleSprite.width / 2;
			_handleSprite.offset.y = _handleSprite.height / 2;
			
			add(_handleSprite);
			add(_plungerSprite);
		}
		
		public function loadXML(xml : XML):void
		{
			var xl : XMLLoader = new XMLLoader(xml);
			
			_plungerSprite.x = xl.data.plunger.x;
			_plungerSprite.y = xl.data.plunger.y;
			
			_handleSprite.x = xl.data.plunger_handle.x;
			_handleSprite.y = xl.data.plunger_handle.y;
			
			_psx = _plungerSprite.x - _plungerSprite.width / 2;
			_sx = _handleSprite.x;
			_ppp = 1 / _plungerSprite.width;
		}
		
		public function grabOverlaps(x : Number, y : Number):Boolean
		{
			return _handleSprite.overlapsPoint(x, y, true);
		}
		
		public function grab():void
		{
			_held = true;
		}
		
		public function letGo():void
		{
			_held = false;
		}
		
		override public function update():void
		{
			if (!_held)
			{
				if (Math.abs(_handleSprite.x - _sx) > 10)
				{
					if (_handleSprite.x < _sx)
					{
						pull(_handleSprite.x + FlxG.elapsed * 100, _handleSprite.y);
					} else {
						pull(_handleSprite.x - FlxG.elapsed * 100, _handleSprite.y);
					}
				}
			}
			
			super.update();
		}
		
		public function pull(x : Number, y : Number):void
		{
			if (x < _sx - 50)
			{
				x = _sx - 50;
			}
			
			if (x > _sx + 50)
			{
				x = _sx + 50;
			}
			
			var p : Number = ((x - _sx) + 50) / 100;
			p = _texture.move(p);
			
			
			var dpx : Number = _px - p;
			dpx = Math.abs(dpx);
			dpx *= 50;
			_stomach.s += dpx;
			_td += dpx;
			
			_px = p;
			
			_handleSprite.x = (_sx - 50) + (p * 100);// x;
			
			var dx : Number = _handleSprite.x - _sx;
			dx /= 2;
			_plungerSprite.scale.x = dx / 50;
			_plungerSprite.scale.x += 1;
			
			_plungerSprite.x = _psx + _plungerSprite.scale.x * _plungerSprite.width / 2;
			
			if (_td > 200)
			{
				_stomach.started = true;
			}
		}
		
		public function getPosition():FlxPoint
		{
			_p.x = _handleSprite.x;
			_p.y = _handleSprite.y;
			
			return _p;
		}
		
	}

}