package scene_1 
{
	import org.flixel.FlxGroup;
	import org.flixel.FlxG;
	import org.flixel.FlxSprite;
	
	/**
	 * ...
	 * @author Marek Kapolka
	 */
	public class Stomach extends FlxGroup 
	{
		[Embed(source = "../../res/scene_1/stomach.png")]
		public static var stomach_png : Class;
		
		[Embed(source = "../../res/scene_1/stomach_crap.png")]
		public static var stomach_crap_png : Class;
		
		private var _stomachSprite : FlxSprite;
		private var _crapSprite : FlxSprite;
		
		private var _started : Boolean = false;
		
		private var _s : Number = 0;
		
		public function Stomach(x : Number, y : Number) 
		{
			//super(x, y, stomach_png);
			super();
			
			_stomachSprite = new FlxSprite(x, y, stomach_png);
			_stomachSprite.offset.x = _stomachSprite.width / 2;
			_stomachSprite.offset.y = _stomachSprite.height / 2;
			
			_crapSprite = new FlxSprite(0, 0, stomach_crap_png);
			_crapSprite.offset.x = _crapSprite.width / 2;
			_crapSprite.offset.y = _crapSprite.height / 2;
			_crapSprite.scale.x = .8;
			_crapSprite.scale.y = .8;
			
			add(_stomachSprite);
			add(_crapSprite);
		}
		
		public function get s():Number
		{
			return _s;
		}
		
		public function set s(n : Number):void
		{
			_s = n;
			
			_crapSprite.angle = _s;
			
			_stomachSprite.scale.x = .95 + Math.sin(n * Math.PI / 180) * .05;
			_stomachSprite.scale.y = .95 + Math.cos(n * Math.PI / 180) * .05;
			
			//_crapSprite.scale.x = _stomachSprite.scale.x;
			//_crapSprite.scale.y = _stomachSprite.scale.y;
		}
		
		public function get started():Boolean
		{
			return _started;
		}
		
		public function set started(b : Boolean):void
		{
			_started = b;
		}
		
		override public function update():void
		{
			if (_started)
			{
				s += FlxG.elapsed * 180;
			}
			
			super.update();
		}
		
		public function loadXML(xml : XMLLoader):void
		{
			_crapSprite.x = xml.data.stomach_crap.x;
			_crapSprite.y = xml.data.stomach_crap.y;
		}
		
	}

}