package scene_2 
{
	import flash.geom.Point;
	import org.flixel.FlxGroup;
	import org.flixel.FlxG;
	import org.flixel.FlxSprite;
	import scene_1.HandCursor;
	
	/**
	 * ...
	 * @author Marek Kapolka
	 */
	public class Cursor extends FlxGroup
	{
		
		private var _hand : FlxSprite;
		private var _dot : FlxSprite;
		
		public function Cursor() 
		{
			super();
			
			_hand = new FlxSprite(0, 0, null);
			_hand.loadGraphic(HandCursor.hands_png, false, false, HandCursor.SPRITE_WIDTH, HandCursor.SPRITE_HEIGHT);
			_hand.offset.x = HandCursor.POINTER_OFFSET_X;
			_hand.offset.y = HandCursor.POINTER_OFFSET_Y;
			
			_hand.addAnimation("idle", [0]);
			_hand.addAnimation("open", [1]);
			_hand.addAnimation("closed", [2]);
			
			_dot = new FlxSprite(0, 0, HandCursor.cursor_dot_png);
			
			add(_hand);
			add(_dot);
			
			_dot.visible = false;
		}
		
		public function play(s : String):void
		{
			_hand.play(s, true);
		}
		
		public function set grabbing(b : Boolean):void
		{
			_dot.visible = b;
		}
		
		public function get grabbing():Boolean
		{
			return _dot.visible;
		}
		
		public function setHandPosition(nx : Number, ny : Number):void
		{
			_hand.x = nx;
			_hand.y = ny;
		}
		
		override public function update():void
		{
			if (!grabbing)
			{
				_hand.x = FlxG.mouse.x;
				_hand.y = FlxG.mouse.y;
			}
			
			_dot.x = FlxG.mouse.x;
			_dot.y = FlxG.mouse.y;
		}
		
	}

}